
#include-once
#include 'Stages/Stage0.au3'
#include 'Stages/Stage1.au3'
#include 'Stages/Stage2.au3'
#include 'Stages/Stage3.au3'
#include 'Stages/Stage4.au3' ; Sub
#include 'Stages/StageZ.au3'
#include 'Examples.au3'

If @ScriptName = 'Include.au3' Then ClipCompress()

Global $sTest = ''

; Zeichnet einen Kreis: ziemlich langsam aber egal.
;~ n = 0
;~ for (y = 0; y < 176; y++)
;~   for (x = 0; x < 176; x++)
;~     a = x - 88
;~     b = y - 88
;~     c = a * a
;~     d = b * b
;~     a = c + d
;~     b = sqrt(a)
;~     if (b < 88) then
;~       color(x, y, b)
;~       rect(x, y, 1, 1)
;~       n++
;~       a = n % 128
;~       if (a = 0) then
;~         drawflush(display1)
;~       endif
;~     endif
;~   next
;~ next
;~ drawflush(display1)
;~ exit

#region Test Stage1

#cs
		['+', 'op add'], _
		['-', 'op sub'], _
		['*', 'op mul'], _
		['/', 'op div'], _
		['^', 'op pow'], _
		['%', 'op mod'], _
		['=', 'op equal'], _
		['<', 'op lessthan'], _
		['>', 'op greaterthan'], _
		['==', 'op strictequal'], _
		['!=', 'op notequal'], _
		['<>', 'op notequal'], _
		['<=', 'op lessthaneq'], _
		['>=', 'op greaterthaneq'], _
		['//', 'op idiv'] _ ; integer division
		]

; __Compile1_Equality_Add
a =  b +  c ; -> op add a  b  c
a =  5 +  c ; -> op add a  5  c
a =  b +  5 ; -> op add a  b  5
a =  5 +  5 ; -> op add a  5  5
; a = -b +  c ; ; -> op add a -b  c [-b forbidden]
a = -5 +  c ; -> op add a -5  c
; a = -b +  5 ; ; -> op add a -b  5 [-b forbidden]
a = -5 +  5 ; -> op add a -5  5
; a =  b + -c ; ; -> op add a  b -c [-c forbidden]
; a =  5 + -c ; ; -> op add a  5 -c [-c forbidden]
a =  b + -5 ; -> op add a  b -5
a =  5 + -5 ; -> op add a  5 -5
; a = -b + -c ; ; -> op add a -b -c [-c & -b forbidden]
; a = -5 + -c ; ; -> op add a -5 -c [-c forbidden]
; a = -b + -5 ; ; -> op add a -b -5 [-b forbidden]
a = -5 + -5 ; -> op add a -5 -5

; __Compile1_Modify_add
a += 1
a += a
a += -1
; a += -a ; ; -> [-a forbidden]
a = 1
a = -1
a = a
; a = -a ; ; -> [-a forbidden]

; __Compile_Stage_1_InlineReplacements_Op_Trig
result = sin(degree)
result = cos(degree)
result = tan(degree)
result = asin(degree)
result = acos(degree)
result = atan(degree)
result = atan2(y,x)
result = angle(y,x)


; __Compile1_BitOpAndOr
result = BitOr(1, 2)
result = BitAnd(1, 2)
result = BitNot(1)
result = BitXor(1, 2)
result = BitShl(1, 2)
result = BitShr(1, 2)
result = And(1, 2)
result = Or(1, 2)

#ce

$sTest &= ClipDecompress("; __Compile1_Equality_AÃÓ×ôþèýôûèÓ×óþÑýóûÑîôíÂéùôõèîóíÑ âùóõÑç×ú×ðáçÑúÑðì×êþÆýêûÆîòíð&Ô áçÆúÆðáîêíÿâùêõÆ¦¦ - a  dd ;À5ÃÁÁÇpÈoÉ Ê>ËÀÌÅÍ + =Â5aÐ¦ÒÀbc Âbn]eØÃÙiÚbÛrÝoÞfà[-ÅÎÁÐ;å¦æÂcÕâÏÆáÓãÔçÔéÕÀïÀcÏñÏÑÏèÎÆìÿ÷bøòãÎÑÓÑÎ×Æ 38")
$sTest &= ClipDecompress("Â__Compile1_Modify_aÇÉ1ÉaÉ-1¦ÂÀÆÅÂÂ-> [ÅforbiÇeÊÈ1È-1Èa¦ÂÀÁÅÂÂ-> [ÅforbiÇeÊ¦¦a = ; ¦À-À+ÁddÃÁÃÆn]0A")
$sTest &= ClipDecompress("; __Compile1_JumpIf¦Éa=5ÎdstÊ5=aÎ55Ë=ÐÒ!=5Ì5Ñ>5Ì_underscoreÑ5Î45Ê5>aÎ45ÑÐÒ>ÐdÀ¦)¦o(tÁoÂgÃ Å (fÇiÈÀÉÊa)Æ Æ)ÍbÌ=ÏË<cË12")
$sTest &= ClipDecompress("; __Compile1_Other¦exit¦reset¦a++¦; 5++ soll einen Error ergeben.¦b--¦goto(100Àgoto(varÀ¦)¦01")
$sTest &= ClipDecompress("; __Compile_Stage_1_InlÔeReplacements_Op_Trig¦ÉsÔÐcosÐÓÒsÔÒcosÒÓÒÓ2(yÕÊÑgle(yÕÁ¦re)¦=  ÂtÃlÅuÆsÇÀÈÁÉeÊÀËgÌeÍdÎ(ÏanÐatÑin,x15")
$sTest &= ClipDecompress("; __Compile1_×pÕÓ¦ÊÐÓÒÕÒNotÁÀÊÐXorÒShlÒShrÑÕÑÓÎ¦)¦(1=  ÂtÃlÅuÆsÇeÈrÉ2À Ë,ÌÁÍitBÏÎÊÑ×rndAÔÐO16")
$sTest &= ClipDecompress("ÊaÒÑaÒÊ5ÒÑ5ÒÊaÐÑaÐÊÓÑÓ¦if)¦bÁ(ÂtÃnÅiÆrÇpÈÀ(À¦dËnÌeÍÉÎÁÏÊ!)É5Ð13")

$sTest &= 'result = read(cell1, 4)' & @CRLF
$sTest &= 'result = getlink(6)' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Op_BasicArithmetic' & @CRLF
$sTest &= 'result = a + b' & @CRLF
$sTest &= 'result = a - b' & @CRLF
$sTest &= 'result = a * b' & @CRLF
$sTest &= 'result = a / b' & @CRLF
$sTest &= 'result += b' & @CRLF
$sTest &= 'result -= b' & @CRLF
$sTest &= 'result *= b' & @CRLF
$sTest &= 'result /= b' & @CRLF
$sTest &= 'result++' & @CRLF
$sTest &= 'result--' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Op_RelationAndLogic' & @CRLF
$sTest &= 'result = a == b' & @CRLF
$sTest &= 'result = a != b' & @CRLF
$sTest &= 'result = a <> b' & @CRLF
$sTest &= 'result = a < b' & @CRLF
$sTest &= 'result = a <= b' & @CRLF
$sTest &= 'result = a > b' & @CRLF
$sTest &= 'result = a >= b' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Draw' & @CRLF
$sTest &= 'clear(r, g, b)' & @CRLF
$sTest &= 'rect(x, y, w, h)' & @CRLF
$sTest &= 'color(r, g, b)' & @CRLF
$sTest &= 'color(r, g, b, a)' & @CRLF
$sTest &= 'lightcolor(illuminator1, col)' & @CRLF
$sTest &= 'stroke(width)' & @CRLF
$sTest &= 'line(x1, y1, x2, y2)' & @CRLF
$sTest &= 'linerect(x, y, w, h)' & @CRLF
$sTest &= 'poly(centerX, centerY, sides, radius, degree)' & @CRLF
$sTest &= 'linepoly(x, y, numSides, radius, degree)' & @CRLF
$sTest &= 'triangle(x1, y1, x2, y2, x3, y3)' & @CRLF
$sTest &= 'image(centerX, centerY, @copper, size, degree)' & @CRLF
$sTest &= 'drawflush(display1)' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Control' & @CRLF
$sTest &= 'enabled(block1, 1)' & @CRLF
$sTest &= 'enabled(block1, 0)' & @CRLF
$sTest &= 'enable(block1)' & @CRLF
$sTest &= 'disable(block1)' & @CRLF
$sTest &= 'config(block1, @copper)' & @CRLF
$sTest &= 'shoot(turret1, x, y, boolShoot)' & @CRLF
$sTest &= 'shootp(turret1, unit, boolShoot)' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Op_Functions' & @CRLF
$sTest &= 'result = max(5, 10)' & @CRLF
$sTest &= 'result = min(5, 10)' & @CRLF
$sTest &= 'result = len(5, 10) ; berechnet result = sqrt(a^2 + b^2)' & @CRLF
$sTest &= 'result = noise(5, 10)' & @CRLF
$sTest &= 'result = abs(-5)' & @CRLF
$sTest &= 'result = log(10)' & @CRLF
$sTest &= 'result = log10(10)' & @CRLF
$sTest &= 'result = floor(5.54321)' & @CRLF
$sTest &= 'result = ceiling(5.54321)' & @CRLF
$sTest &= 'result = sqrt(10)' & @CRLF
$sTest &= 'result = random(10) ; float from interval (0, 10)' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Op_IdivModPow' & @CRLF
$sTest &= 'result = 50 // 9' & @CRLF
$sTest &= 'result //= 3' & @CRLF
$sTest &= 'result = 100 % 7' & @CRLF
$sTest &= 'result %= 5' & @CRLF
$sTest &= 'result = 5^3' & @CRLF
$sTest &= 'result ^= 2' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Jump' & @CRLF
$sTest &= 'if(a=b)goto(10)' & @CRLF
$sTest &= 'if(a==b)goto(10)' & @CRLF
$sTest &= 'if(a!=b)goto(10)' & @CRLF
$sTest &= 'if(a<>b)goto(10)' & @CRLF
$sTest &= 'if(a<b)goto(10)' & @CRLF
$sTest &= 'if(a<=b)goto(10)' & @CRLF
$sTest &= 'if(a>b)goto(10)' & @CRLF
$sTest &= 'if(a>=b)goto(10)' & @CRLF
$sTest &= 'goto(10)' & @CRLF & @CRLF

$sTest &= '; __Compile_Stage_1_InlineReplacements_Print' & @CRLF
$sTest &= 'print("test")' & @CRLF
$sTest &= 'print(100)' & @CRLF
$sTest &= 'print(a)' & @CRLF
$sTest &= 'printflush(message1)' & @CRLF & @CRLF

#EndRegion

#region Test Stage0

$sTest &= '; _Compile_Stage_0_InlineRenames' & @CRLF
$sTest &= 'result = sensor(block1, @phaseFabric)' & @CRLF
$sTest &= 'result = sensor(block1, @surgeAlloy)' & @CRLF
$sTest &= 'result = sensor(block1, @sporePod)' & @CRLF
$sTest &= 'result = sensor(block1, @blastCompound)' & @CRLF & @CRLF

$sTest &= '; _Compile_Stage_0_AddEOFIfNeeded' & @CRLF
$sTest &= 'exit ; beendet den Prozessor hier' & @CRLF
$sTest &= 'reset ; startet den Prozessor von vorne, Variablen bleiben erhalten' & @CRLF
$sTest &= 'goto(999)' & @CRLF & @CRLF


#EndRegion






Func ClipCompress()
	ClipPut('ClipDecompress("' & _TComp_Compress(StringReplace(ClipGet(), @CRLF, '¦', 0, 1)) & '")')
EndFunc

Func ClipDecompress($s)
	Return StringReplace(_TComp_Decompress($s), '¦', @CRLF, 0, 1)
EndFunc
;~ €ƒ…†‡ˆ‰Š‹ŒŽ•˜™š›œžŸ¡¢£¤¥§¨©ª«¬®¯±µ¶º»¼½¾¿ÀÁÂÃÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕ×ØÙÚÛÝÞàáâãåæçèéêìíîïðñòóôõ÷øùúûýþÿ
Func _TComp_Decompress($sString, $iLenReplace = 2, $sCharSet = 'ÀÁÂÃÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕ×ØÙÚÛÝÞàáâãåæçèéêìíîïðñòóôõ÷øùúûýþÿ')
    Local $iCnt = Int('0x' & StringRight($sString, 2)), $aZeichen = StringSplit(StringRight(StringReverse($sCharSet), $iCnt), '', 2)
    $sString = StringTrimRight($sString, 2)
    For $i = 0 To $iCnt - 1 Step 1
        $sString = StringReplace(StringTrimRight($sString, $iLenReplace), $aZeichen[$i], StringRight($sString, $iLenReplace), 0, 1)
    Next
    Return $sString
EndFunc

Func _TComp_Compress($sString, $iLenReplace = 2, $sCharSet = 'ÀÁÂÃÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕ×ØÙÚÛÝÞàáâãåæçèéêìíîïðñòóôõ÷øùúûýþÿ', $HowFastFrom0To99 = 0) ; 0 -> Exakt, 9 = Sqrt
    Local $iLen_Old = StringLen($sString), $iLen_New = 0, $sTmp = '', $n = 0, $aZeichen = StringSplit($sCharSet, '', 2), $iLenCharSet = StringLen($sCharSet)
    While 1
        $sTmp = _TComp_Analyse($sString, $iLenReplace, $HowFastFrom0To99)
		$HowFastFrom0To99 = $HowFastFrom0To99^0.9975
        $sString = StringReplace($sString, $sTmp, $aZeichen[$n], 0, 1) & $sTmp
        $iLen_New = StringLen($sString)
        $n += 1
        If ($n = $iLenCharSet) Or ($iLen_New >= $iLen_Old) Then ExitLoop
        $iLen_Old = $iLen_New
    WEnd
    Return $sString & Hex($n, 2)
EndFunc

Func _TComp_Analyse($sData, $iLenReplace = 2, $HowFastFrom0To99 = 0)
    Local $Top[2], $sTmp, $iEnd = StringLen($sData) - $iLenReplace + 1
	$iEnd = Round($iEnd^(1-$HowFastFrom0To99/100))
    For $i = 0 To $iEnd Step 1
        $sTmp = StringMid($sData, $i, $iLenReplace)
		StringReplace($sData, $sTmp, $sTmp, 0, 1)
		If @extended >= $Top[0] Then
			$Top[0] = @extended
			$Top[1] = $sTmp
        EndIf
    Next
    Return $Top[1]
EndFunc